<?php
namespace SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm_00024_000_tab_despesa_de_Mao_de_ObraService;
use SM\Traits\TResponse;

class Sm_00024_000_tab_despesa_de_Mao_de_ObraController
{

    use TResponse;

    protected $despesaMaoObraService;

    public function __construct(Sm_00024_000_tab_despesa_de_Mao_de_ObraService $despesaMaoObraService)
    {
        $this->despesaMaoObraService = $despesaMaoObraService;
    }

    public function getmaoobracontctbl()
    {
        try {
            $data = $this->despesaMaoObraService->getmaoobracontctbl();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getservicoorca()
    {
        try {
            $data = $this->despesaMaoObraService->getservicoorca();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getcontctbl()
    {
        try {
            $data = $this->despesaMaoObraService->getcontctbl();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function adicionar_desp_mao_obra(Request $request)
    {
        try {
            $this->despesaMaoObraService->adicionar_desp_mao_obra($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    } 
    
    public function excluir_desp_mao_obra(Request $request)
    {
        try {
            $params = $request->getParameters();
            $this->despesaMaoObraService->excluir_desp_mao_obra($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

   }
