<?php
namespace SM\Service;

use SM\Factory\Sm_00024_000_tab_tipos_Operacoes_DespesasFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Sm_00024_000_tab_tipos_Operacoes_DespesasService
{

    protected $tiposOperacoesDespesasFactory;
    protected $environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, Sm_00024_000_tab_tipos_Operacoes_DespesasFactory $tiposOperacoesDespesasFactory, Environment $environment, NewCode $newCode)
    {
        $this->connection          = $entityManager->getConnection();
        $this->tiposOperacoesDespesasFactory = $tiposOperacoesDespesasFactory;
        $this->environment         = $environment;
        $this->newCode             = $newCode;
    }

    public function gettpoperdespdiv()
    {
        return $this->tiposOperacoesDespesasFactory->gettpoperdespdiv();
    }

    public function gettipooperac()
    {
        return $this->tiposOperacoesDespesasFactory->gettipooperac();
    }

    public function adicionar_tip_oper_desp($params)
    {
        
        try {          
            $nrorg = $this->environment->getNrOrg();
            $cdoperador = $this->environment->getCdOperador();
            $novoCodigo = $this->newCode->getCodeByTableName("FCT_TPOPERDESPDIV", $nrorg, 1, 10, true);
            // var_dump($params); die;
            $dataParams = array(
                "NRTPOPERDESPDIV"        => $novoCodigo,
                "CDTIPOOPER"             => $params[0]["CDTIPOOPER"],
                "IDENTRSAIDOP"           => $params[0]["IDENTRSAIDOP"],
                "NRORG"                  => $nrorg,
                "NRORGINCLUSAO"          => $nrorg,
                "CDOPERINCLUSAO"         => $cdoperador,
                "NRORGULTATU"            => $nrorg,
                "CDOPERULTATU"           => $cdoperador                
            );

            $itemRepetido = $this->tiposOperacoesDespesasFactory->verificarItemRepetido($dataParams);
    
            if ($itemRepetido[0]["EXISTE"] > 0) {
                throw new \Exception("Operação Bloqueada! O item selecionado já existe.");
            }
            $this->tiposOperacoesDespesasFactory->adicionar_tip_oper_desp($dataParams);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function excluir_tip_oper_desp($parametro)    
    {
        $param = implode(',', $parametro["TOD"]);
        $this->tiposOperacoesDespesasFactory->excluir_tip_oper_desp($param);
    }

}

