import Vue from 'vue';
import Zeedhi from '@zeedhi/vue';
import ZeedhiComponents from '@zeedhi/vuetify';
import TeknisaComponents from '@zeedhi/teknisa-components-vuetify';
import TekLibComponents from '@zeedhi/tek-lib';
import { ZdFieldGroup } from '@zeedhi/zd-field-group';
import { VueSpeechRecognition } from '@zeedhi/zd-speech-recognition';
import { ZdSplitPane } from '@zeedhi/zd-split-pane';
import { ZdRichText } from '@zeedhi/zd-richtext';
import { Icons } from '@zeedhi/common';
import { Messages } from '@zeedhi/core';
import { ZdDashboardGrid } from '@zeedhi/zd-dashboard-grid';
import {
    ZdECharts, echartsCore, echartsCharts, echartsComponents,
} from '@zeedhi/zd-echarts';
import router from '../router';
import controllers from '../controllers';
import config from '../config/config';
import '@zeedhi/common/dist/style.css';
import '@zeedhi/vuetify/dist/zd-style.css';
import vuetify from './vuetify';

Icons.addIcons({
    iconName: 'mdi-icon-id',
});

Vue.use(Zeedhi, {
    controllers,
    router,
    config,
});
Vue.use(ZeedhiComponents);
Vue.use(TeknisaComponents);
Vue.use(TekLibComponents);
Vue.component('ZdSplitPane', ZdSplitPane);
Vue.component('VueSpeechRecognition', VueSpeechRecognition);
Vue.component('ZdFieldGroup', ZdFieldGroup);
Vue.component('ZdRichText', ZdRichText);
Vue.component('ZdDashboardGrid', ZdDashboardGrid);
Vue.component('ZdECharts', ZdECharts);

echartsCore.use([
    echartsCharts.PieChart,
    echartsCharts.BarChart,
    echartsCharts.LineChart,
    echartsComponents.GridComponent,
    echartsComponents.DataZoomComponent,
]);

vuetify.framework.icons.values = Icons.getIcons() as any;

Messages.add({
    'pt-BR': {
        translation: {
            KEY: 'valor',
        },
    },
    'es-CL': {
        translation: {
            KEY: 'valor',
        },
    },
    'es-CO': {
        translation: {
            KEY: 'valor',
        },
    },
    'es-ES': {
        translation: {
            KEY: 'valor',
        },
    },
    'en-US': {
        translation: {
            KEY: 'value',
        },
    },
});
